// ======================================================================================================================================
//********************************************  ARDURACK REV001 BY CAVISYNTH - COPYRIGHT 2016  ******************************************
// **********************************************  cavimaster@gmail.com - info@cavisynth.com  *******************************************
// **********************************************  Stéphane Caviglioli  *****************************************************************
// **********************************************  REV001-078  | 13.12.2018 *************************************************************
// ======================================================================================================================================
#include <FreqMeasure.h> // Include pour l'accordeur 440Hz
int FORMES_OUT = 6;  //sortie des formes d'ondes
byte LED_OUT = 13;  //sortie LED clock
byte GATE = 8;  //Entrée GATE
byte ledState = LOW; 
bool PWMState = false;
unsigned long  Time;
float freq;
unsigned long  previousMillis = 0;
unsigned long  previousPulseMillis = 0; 
int mode_pot,mode,last_mode,pot ;
int supermode = 0;
int supertrig = 0;
float volt1,volt_pot,volt_tot,frequency;
int freq_to_0V = 32;
// *********************************************************************** TRIGGER BTN
byte TRIGGERBTN = 3; //entrée du bouton trigger
int TRIGGERBTN_STATE;
int LAST_TRIGGERBTN_STATE;
int startPressed = 0;    // the time button was pressed
int endPressed = 0;      // the time button was released
int timeHold = 0;        // the time button is hold
int timeReleased = 0;    // the time button is released
int countBtn = 0;
// *********************************************************************** TRIGGER BTN
// *********************************************************************** TAP TEMPO
#define DEBOUNCE_DELAY 40     // length of debounce "wait period" -40
#define HOLD_DELAY 750       //750
#define RESET_TIME 2002       // Time it takes for the current timer and tap count to reset if only one tap is put in-2002
byte outputCount = 0;
byte tapCount = 0;
byte intervalCount = 0;
byte TAPBTN_STATE; // temporary button state storage (used in debounce routine)
byte LAST_TAPBTN_STATE = LOW;   // the previous TRIGGERBTN_STATE from the input pin
byte tapState = HIGH;         // current tap button state
byte lastTapState = HIGH;     // the last tap button state 
byte divisor;
byte OUTPUT_TIME = 2;
int alpha;
int currentTimer[3];                 // array of most recent tap counts
float interval;
unsigned long timeoutTime = 0;       // this is when the timer will trigger next 
unsigned long indicatorTimeout;      // sets the turn off time for the LED
unsigned long lastDebounceTime = 0;  // the last time the output pin was toggled
unsigned long lastTap;               // when the last tap happened 
// *********************************************************************** TAP TEMPO
// *********************************************************************** ACCORDEUR & GATE
double sum = 0;
int count = 0;
int g = 0;
// *********************************************************************** ACCORDEUR & GATE

void setup() { // =========================================================================> SETUP
   pinMode(FORMES_OUT, OUTPUT); 
   pinMode(LED_OUT, OUTPUT);
   pinMode(TRIGGERBTN,INPUT_PULLUP);
   mode_pot = map(analogRead(A1), 0, 1023, 0, 100);
   if(mode_pot >= 0 && mode_pot < 9)    {last_mode = 1;}
   if(mode_pot > 9 && mode_pot < 26)   {last_mode = 2;}
   if(mode_pot > 26 && mode_pot < 43)  {last_mode = 3;}
   if(mode_pot > 43 && mode_pot < 61)  {last_mode = 4;}
   if(mode_pot > 61 && mode_pot < 78)  {last_mode = 5;}
   if(mode_pot > 78 && mode_pot < 93)  {last_mode = 6;}
   if(mode_pot > 93 && mode_pot <= 100) {last_mode = 7;}
    FreqMeasure.begin();//Mesure de la fréquence pour accordeur
  //Serial.begin(9600); 
}
 
void loop() { 
// =======================================================================================> LECTURE DU POTENTIOMETRE DE MODESELEKTOR ET DU BOUTON DE TRIGGER
   mode_pot = map(analogRead(A1), 0, 1023, 0, 100); //Lecture du mode
    if(mode_pot >= 0 && mode_pot < 9)    {mode = 1;}
    if(mode_pot > 9 && mode_pot < 26)   {mode = 2;}
    if(mode_pot > 26 && mode_pot < 43)  {mode = 3;}
    if(mode_pot > 43 && mode_pot < 61)  {mode = 4;}
    if(mode_pot > 61 && mode_pot < 78)  {mode = 5;}
    if(mode_pot > 78 && mode_pot < 93)  {mode = 6;}
    if(mode_pot > 93 && mode_pot <= 100) {mode = 7;}
   if(mode != last_mode){
      software_Reset(); 
      if(ledState = HIGH){digitalWrite(LED_OUT, 0 );} 
   } last_mode = mode; //RESET SI CHANGEMENT DE MODE  !IMPORTANT!

   //******************************************************************************* 1V/oct
   volt1 = analogRead(A3)*(5.000 / 1023.000); //lecture CV et conversion en voltage
   volt_pot = analogRead(A0)*(5.000 / 1023.000); //lecture Pot  //lecture Pot
   volt_tot =  volt1 + volt_pot;
   frequency = freq_to_0V*pow(2,volt_tot);
   
// =======================================================================================> LECTURE DES POTENTIOMETRES

// ======================================================================================== >>>>>>>>>>>>>>>> MODES
// ========================================================================================   
   if (mode == 1 ){ // ====================================================================> A -> MODE TRIGGER [OK]
        if(ledState = HIGH){digitalWrite(LED_OUT, 0 );}
        pot = map(analogRead(A0), 0, 1020, 2, 100); //Lecture du potensiometre de règlage
        pot  = (pot + voltToMs())/2;
        TRIGGERBTN_STATE = digitalRead(TRIGGERBTN); 
        if(TRIGGERBTN_STATE == LOW && TRIGGERBTN_STATE != LAST_TRIGGERBTN_STATE && analogRead(A0)!=1023){
           analogWrite(FORMES_OUT, 255); analogWrite(LED_OUT, 255); 
           delay(pot); // Delay du trigger = valeur du potentiometre (2-100ms)
           analogWrite(FORMES_OUT, 0);
           delay(100);
         }
         if(analogRead(A0)==1023){ analogWrite(FORMES_OUT, 255); analogWrite(LED_OUT, 255); }
         if(analogRead(A0)<1023){ analogWrite(FORMES_OUT, 0); analogWrite(LED_OUT, 0); }
       LAST_TRIGGERBTN_STATE = TRIGGERBTN_STATE;
   }// FIN MODE TRIGGER
// ======================================================================================== 
    if (mode == 2 ){ // ===================================================================> B -> TAP TEMPO TRIGGER [OK]
        if(ledState = HIGH){digitalWrite(LED_OUT, 0 );}
        OUTPUT_TIME = map(analogRead(A0), 0, 1023, 2, 100); //Lecture du potensiometre de règlage
        OUTPUT_TIME  = (pot + voltToMs())/2;
        TAPBTN_STATE = digitalRead(TRIGGERBTN);
        tapState = debounce(TAPBTN_STATE, LAST_TAPBTN_STATE, &lastDebounceTime, DEBOUNCE_DELAY, HOLD_DELAY);
        LAST_TAPBTN_STATE = TAPBTN_STATE;  // save the state for comparison on the next loop
       if( tapState == LOW && tapState != lastTapState )  {  // button just changed from HIGH to LOW
          if (tapCount != 0) {                                // We've already recorded a tap in this set
       tapCount++;
       for(int n = 2; n > 0; n--){currentTimer[n] = currentTimer[n-1];}
       currentTimer[0] = millis() - lastTap;  // calculate the tap interval
       lastTap = millis();                    // Store the tap time for the next loop
       outputCount = 0;                       // reset pulse count to zero
       intervalCount = tapCount - 1;
       alpha = currentTimer[0] + currentTimer[1] + currentTimer[2];
       divisor = constrain(intervalCount,0,3);
       interval = alpha/divisor;
       }else {lastTap = millis();tapCount++;}}
       lastTapState = tapState; // keep track of the state for the next loop
       if (millis() >= timeoutTime){
       outputCount++;
       indicatorTimeout = millis() + OUTPUT_TIME;  // set the time for the output to turn back off 
       timeoutTime = millis() + (interval);}
       if(TAPBTN_STATE == LOW){if ((millis() - lastTap >1100)) { software_Reset(); clearTaps();}} //RESET
       if(interval){
       if( millis() < indicatorTimeout ) {PORTD = 255; digitalWrite(LED_OUT, 255 );}
       else {PORTD = 0; digitalWrite(LED_OUT, 0 );}}
       if (currentTimer[0] != 0 | millis() - lastTap > RESET_TIME){clearTaps();}  
   }// FIN MODE TAP TRIGGER
// ======================================================================================== 
     if (mode == 3){ // ===================================================================> 3 ->  C - MODE MODULATOR /LFO [OK]
    
     pot = map(analogRead(A0), 0, 1023, 2500, 25); //Lecture du potensiometre de règlage
     pot  = (pot + voltToMod())/2;
      TRIGGERBTN_STATE = digitalRead(TRIGGERBTN); 
   if(TRIGGERBTN_STATE == LOW){ pot = pot/2;}
    unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= pot) {
    previousMillis = currentMillis;
    if (ledState == LOW) {ledState = HIGH;} 
    else {ledState = LOW;}
    digitalWrite(FORMES_OUT, ledState); digitalWrite(LED_OUT, ledState); }
    }// MODE MODULATOR /LFO
// ======================================================================================== 
    if (mode == 4){ // ===================================================================> D -> forme d'onde 1 (SIMPLE SQUARE)[OK]
       if(BtnCount(2,digitalRead(TRIGGERBTN))== 0){ tone(6,frequency); analogWrite(LED_OUT, 255);}//si mode GATE pas activé
       if(BtnCount(2,digitalRead(TRIGGERBTN))== 1){ //si mode GATE activé
         if(digitalRead(GATE) == 1){ tone(6,frequency);analogWrite(LED_OUT, 255);} 
         if(digitalRead(GATE) == 0){ noTone(6); analogWrite(LED_OUT, 0); }
    }//fin mode GATE
   }// FIN MODE forme
// ======================================================================================== 
    if (mode == 5){ // ===================================================================> E -> forme d'onde 2 (COMPLEXE SQUARE 1)[OK]
    
      if(BtnCount(2,digitalRead(TRIGGERBTN))== 0){  tone(6,frequency); Forme1(2000/frequency); analogWrite(LED_OUT, 255);}//si mode GATE pas activé
      if(BtnCount(2,digitalRead(TRIGGERBTN))== 1){ //si mode GATE activé
           if(digitalRead(GATE) == 1){tone(6,frequency);
            Forme1(2000/frequency);
           analogWrite(LED_OUT, 255); 
          }
          if(digitalRead(GATE) == 0){ noTone(6); analogWrite(LED_OUT, 0); }
    }//fin mode GATE
   }// FIN MODE forme
// ======================================================================================== 
    if (mode == 6){ // ===================================================================> F -> forme d'onde 3 (COMPLEXE SQUARE 2)[OK]
    
       if(BtnCount(2,digitalRead(TRIGGERBTN))== 0){  tone(6,frequency);  Forme2(1000/frequency); analogWrite(LED_OUT, 255);}//si mode GATE pas activé
      if(BtnCount(2,digitalRead(TRIGGERBTN))== 1){ //si mode GATE activé
          if(digitalRead(GATE) == 1){ 
          tone(6,frequency);
          //tone(6,voltToFreq(analogRead(A3)));
         Forme2(1000/frequency);
         analogWrite(LED_OUT, 255); 
         } 
           if(digitalRead(GATE) == 0){ noTone(6); analogWrite(LED_OUT, 0); }
     }//fin mode GATE
   }// FIN MODE forme
// ======================================================================================== 
       if (mode == 7 && supermode !=1 ){ // ================================================================> G -> forme d'onde 3 (NOISE) [OK]
       
        if(BtnCount(2,digitalRead(TRIGGERBTN))== 0){   Forme3(); analogWrite(LED_OUT, 255); }//si mode GATE pas activé
        if(BtnCount(2,digitalRead(TRIGGERBTN))== 1){ //si mode GATE activé
         if(digitalRead(GATE) == 1){ Forme3(); analogWrite(LED_OUT, 255); }
          if(digitalRead(GATE) == 0){  analogWrite(LED_OUT, 0); }
        }//fin mode GATE
  // ==============================================================> SUPERMODE
TRIGGERBTN_STATE = digitalRead(TRIGGERBTN); 
  if (TRIGGERBTN_STATE != LAST_TRIGGERBTN_STATE) {
      if (TRIGGERBTN_STATE == LOW) {startPressed = millis(); timeReleased = startPressed - endPressed;} 
      else {
          endPressed = millis();
          timeHold = endPressed - startPressed;
          if (timeHold >=2000 && supermode == 0) {supermode = 1; delay(5);}
      }
  }
 LAST_TRIGGERBTN_STATE = TRIGGERBTN_STATE;
   // ==============================================================> SUPERMODE

   
   }// FIN MODE forme noise
// ======================================================================================== 
    if ( supermode == 1 ){ // ================================================================================> 9 -> ACCORDEUR (TUNER) 440H
     
      if (FreqMeasure.available()) {
      sum = sum + FreqMeasure.read();
      count = count + 1;
      if (count > 15) {
      float frequency = FreqMeasure.countToFrequency(sum/count);
      frequency = frequency - 0.18;
      //Serial.println(frequency);
      tone(6,frequency);
      if(!frequency){LedBlink(1000);}
      if(frequency < 435.00){LedBlink(round(13000/frequency));} // moins que 435
      if(frequency > 435 && frequency < 439.80){LedBlink(round(50000/frequency));} //435 -> 439.8
      if(frequency < 440.20 && frequency > 439.80){digitalWrite(LED_OUT, HIGH);} // 440
       if(frequency > 440.20 && frequency < 445){LedBlink(round(frequency/5));} //435 -> 439.8
      if(frequency > 445.00){LedBlink(round(frequency/13));} // plus que 445
      sum = 0; count = 0;
    }
  }
   delay(1);  
   }// FIN ACCORDEUR (TUNER) 440Hz
  
} //fin void loop
// ======================================================================================== >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> FONCTIONS
// =======================================================================================> LED BLINK
void LedBlink(int i){
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= i) {
    previousMillis = currentMillis;
    if (ledState == LOW) {ledState = HIGH;} 
    else {ledState = LOW;}
    digitalWrite(LED_OUT, ledState); }}
// =======================================================================================> RESET TAP TEMPO
void clearTaps(){
  for(int t = 0; t < 3; t++){currentTimer[t] = 0;
  if(currentTimer[t + 1] == 0){ break;}}
  tapCount = 0; } 
// =======================================================================================> DEBOUNCE TAP TEMPO 
byte debounce(byte _TAPBTN_STATE, byte _LAST_TAPBTN_STATE, unsigned long *_lastDebounceTime, int _holdDelay, byte dbounceTime)
{
  byte state = HIGH;
  if (_TAPBTN_STATE != _LAST_TAPBTN_STATE) {*_lastDebounceTime = millis();}
  if ((millis() - *_lastDebounceTime) >= _holdDelay && state == HIGH) {state = _TAPBTN_STATE;}
  else{state = HIGH;}
  if ((millis() - *_lastDebounceTime) >= dbounceTime && state == LOW){state = _TAPBTN_STATE; clearTaps();}
  return state;}
// =======================================================================================> GENERTEUR DE FREQUENCE CARRE SELON TEMPS
void pulseOUT(unsigned long t){ 
if(millis() - previousMillis> t/2){
      previousPulseMillis = millis();
      if(PORTD  == 0){PORTD = 255; digitalWrite(LED_OUT, HIGH);}
      else{PORTD = 0; digitalWrite(LED_OUT, LOW);}}
 
} // fin pulseOUT
// =======================================================================================> COMPLEXE SQUARE 1 
void Forme1(float t){
 if(millis() - previousMillis> t/2){
   previousMillis = millis();
  for (int i=0;i<255;i++) { PORTD = i; }
  }
}
// =======================================================================================> COMPLEXE SQUARE 2
void Forme2(float t){ 
if(millis() - previousMillis> t/2){
   previousMillis = millis();
  for (int i=0;i<255;i++) { PORTD = i; }
  for (int i=255;i>0;i--) { PORTD = i; }
  }
} 
// =======================================================================================> NOISE  
void Forme3(){ //noise
   pot = map(analogRead(A0), 0, 1023, 65, 100); //Lecture du potensiometre de règlage 
  for (int i=0;i<255;i++) {int r = random(0,pot); PORTD = r;} 
}
// =======================================================================================> NOISE 


// =======================================================================================> CONVERTISSEUR VOLT EN MILLISECONDS
int voltToMs(){
    float voltage = analogRead(A3);
    int ms = map(voltage,0,1023,0,100);
    return (ms);
}
// =======================================================================================> CONVERTISSEUR VOLT EN MILLISECONDS (modulation)
int voltToMod(){
    float voltage = analogRead(A3);
    int ms = map(voltage,0,1023,25,2500);
    return (ms);
}

// =======================================================================================> COMPTEUR DE BOUTON
int BtnCount(int nb,byte STATE){
  if (STATE != LAST_TRIGGERBTN_STATE) {
      if (STATE == LOW) {count++;} 
      if(count == nb){ count=0;}
  }
 LAST_TRIGGERBTN_STATE = STATE;
 return count;
} 

// =======================================================================================> RESET
void software_Reset(){
  asm volatile ("  jmp 0"); 
  delay(500);
} 

